#include <iostream>
#include <vector>
#include <map>

using namespace std;

signed main() {
    int n, q; cin >> n >> q;
    vector<map<int, int>> cnt(n);
    vector<int> cnt_e(n), cnt_bad(n);
    int ans = 0;

    auto add_v = [&](int v, int color) {
        ++cnt[v][color];

        if (cnt[v][color] == 2) {
            ++cnt_bad[color];
        }
    };

    auto del_v = [&](int v, int color) {
        --cnt[v][color];

        if (cnt[v][color] == 1) {
            --cnt_bad[color];
        }
    };

    while (q--) {
        char t; cin >> t;
        int a, b, color;
        cin >> a >> b >> color;
        --a; --b; --color;

        if (a > b) swap(a, b);

        if (cnt_bad[color] == 0) ans -= cnt_e[color];
        if (t == '+') {
            add_v(a, color);
            add_v(b, color);

            cnt_e[color]++;
        } else {
            del_v(a, color);
            del_v(b, color);

            cnt_e[color]--;
        }
        if (cnt_bad[color] == 0) ans += cnt_e[color];

        cout << ans << "\n";
    }
}