/* 10-1-11-12-E */

#include <iostream>
#include <algorithm>

typedef signed long long SLL;
struct vec2
{
  double X, Y;

    vec2( )
  {
  }


  vec2( double X, double Y ): X(X), Y(Y)
  {
  }

  double length( void )
  {
    return sqrt(X * X + Y * Y);
  }

  vec2 operator+( vec2 k )
  {
    return {X + k.X, Y + k.Y};
  }

  vec2 operator-( vec2 k )
  {
    return {X - k.X, Y - k.Y};
  }

  vec2 operator*( double k )
  {
    return {X * k, Y * k};
  }
};

int main( void )
{
  int x0, y0, x1, y1, x2, y2;

  std::cin >> x0 >> y0 >> x1 >> y1 >> x2 >> y2;

  vec2 A0(x0, y0), A1(x1, y1), A2(x2, y2);

  double len0 = (A1 - A0).length();
  double len1 = (A2 - A1).length();
  double len2 = (A2 - A0).length();
  double pp = (len0 + len1 + len2) / 2.0;

  double S = sqrt(pp * (pp - len0) * (pp - len1) * (pp - len2));

  double h0 = S / len0 * 2;
  double h1 = S / len1 * 2;
  double h2 = S / len2 * 2;

  double mn = std::min(h2, std::min(h0, h1));
  if (mn == h0)
  {
    std::cout << A0.X << " " << A0.Y << " " << A1.X << " " << A1.Y;
  }
  if (mn == h1)
  {
    std::cout << A1.X << " " << A1.Y << " " << A2.X << " " << A2.Y;
  }
  if (mn == h2)
  {
    std::cout << A0.X << " " << A0.Y << " " << A2.X << " " << A2.Y;
  }
}

