#include <algorithm>
#include <cmath>
#include <iostream>
#include <cstdlib>
#include <string>
#include <vector>

using namespace std;
typedef long long ll;
typedef long double ld;

void solved()
{
  ll n, m, s, S;
  cin >> n >> m >> s;
  S = n * m;
  if (s == S)
  {
    cout << 0;
    return;
  }
  if (s % n == 0 || s % m == 0)
  {
    cout << 1;
    return;
  }
  if (n > m)
    swap(n, m);
  for (int i = 1; i < (n + 1) / 2; i++)
    for (int j = 1; j < (m + 1) / 2; j++)
    {
      ll
        s1 = ll(i) * j,
        s2 = (n - i) * j,
        s3 = (m - j) * i,
        s4 = (m - j) * (n - i);
      if (s1 == s || s2 == s || s3 == s || s4 == s ||
        s1 + s4 == s || s2 + s3 == s || s == S - s1 ||
        s == S - s2 || s == S - s3 || s == S - s4)
      {
        cout << 2;
        return;
      }
    }
  ll x1 = s % n, x2 = s % m, k1 = s / n, k2 = s / m;
  if (x1 == m - k1 || x2 == n - k2 || m - k1 == 1 || n - k2 == 1)
  {
    cout << 2;
    return;
  }

  cout << 3;
}

void solveh()
{
  ll n, q;
  cin >> n >> q;
  
  // vector<
  // for (int i = 0; i < q; i++)
  // {
  //   char s;
  //   int v, u, c;
  //   cin >> s >> v >> u >> c;
  //   if (s == '+')
  //   {
  //   }
  //   else if (s == '-')
  //   {
  //   }
  // }
}

void solvei()
{

}

void solvej()
{
  ll t = 7, r = 7, b = 0, l = 0;

  int xm = 4, ym = 4;

  cout << '?' << xm << ym << endl;
  char s;
  cin >> s;
  do
  {
    if (s == '+')
    {
      if (xm < 0)
        l = -xm;
      else
        r = 7 - xm;
      if (ym < 0)
        b = -ym;
      else
        t = 7 - xm;

    }
    else if (s == '-')
    {
    }
  } while (0);
}

void solvem()
{
  ll x1, y1, x2, y2, x3, y3;
  cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
  
  ld dist = 1e10;
  ll rx1, ry1, rx2, ry2;
  {
    ll a = y2 - y1;
    ll b = x1 - x2;
    ll c = -b * y1 - a * x1;

    ld h = abs(a * x3 + b * y3 + c) * 1.0 / sqrt(a * a + b * b);
    if (h < dist)
    {
      rx1 = x1, rx2 = x2, ry1 = y1, ry2 = y2;
      dist = h;
    }
  }
  {
    ll a = y3 - y1;
    ll b = x1 - x3;
    ll c = -b * y1 - a * x1;

    ld h = abs(a * x2 + b * y2 + c) * 1.0 / sqrt(a * a + b * b);
    if (h < dist)
    {
      rx1 = x1, rx2 = x3, ry1 = y1, ry2 = y3;
      dist = h;
    }
  }
  {
    ll a = y2 - y3;
    ll b = x3 - x2;
    ll c = -b * y3 - a * x3;

    ld h = abs(a * x1 + b * y1 + c) * 1.0 / sqrt(a * a + b * b);
    if (h < dist)
    {
      rx1 = x2, rx2 = x3, ry1 = y2, ry2 = y3;
      dist = h;
    }
  }
  cout << rx1 << ' ' << ry1 << ' ' << rx2 << ' ' << ry2;
}

int main()
{
  solved();
}
