#include <iostream>
#include <cmath>
#include <cstdlib>
#include <algorithm>
using namespace std;

using UINT64 = unsigned long long;
using INT64 = long long;

unsigned long long Power( UINT64 A, UINT64 Power )
{
	UINT64 res = 1;

	for (UINT64 i = 0; i < Power; i++)
		res *= A;

	return res;
}

int main47(void)
{
	UINT64 n, x;
	UINT64 p;

	std::cin >> n >> x;

	p = Power(10, n);

	if (x > p || x < 0)
	{
		cout << "NO";
		return 0;
	}

	cout << "YES" << endl;
	cout << x << ' ' << p;

	return 0;
}

inline INT64 Pow2( INT64 X )
{
	return X * X;
}

inline INT64 Max3( INT64 a, INT64 b, INT64 c)
{
	return max(max(a, b), c);
}

int main(void)
{
	INT64 x1, y1, x2, y2, x3, y3;

	cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

	INT64 l1 = Pow2(x2 - x1) + Pow2(y2 - y1);
	INT64 l2 = Pow2(x3 - x1) + Pow2(y3 - y1);
	INT64 l3 = Pow2(x3 - x2) + Pow2(y3 - y2);

	INT64 m = Max3(l1, l2, l3);

	if (m == l1)
	{
		cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2;
	}
	else if (m == l2)
	{
		cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3;
	}
	else
		cout << x2  << ' ' << y2 << ' ' << x3 << ' ' << y3 << ' ';

	return 0;
}