#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int n, q; cin >> n >> q;
    vector<int> beauty(1e5+1);
    vector<map<int, int>> cnt(1e5+1);
    vector<set<int>> to_perfect(1e5+1);
    int ans = 0;

    while (q--) {
        char t; int u, v, c;
        cin >> t >> u >> v >> c;
        u--; v--;

        if (to_perfect[c].empty()) {
            ans -= beauty[c];
        }
        if (t == '+') {
            beauty[c] += 1;
            cnt[c][u] += 1;
            if (cnt[c][u] == 2) {
                to_perfect[c].insert(u);
            }
            cnt[c][v] += 1;
            if (cnt[c][v] == 2) {
                to_perfect[c].insert(v);
            }
        } else {
            beauty[c] -= 1;
            cnt[c][u] -= 1;
            if (cnt[c][u] == 1) {
                to_perfect[c].extract(u);
            }
            cnt[c][v] -= 1;
            if (cnt[c][v] == 1) {
                to_perfect[c].extract(v);
            }
        }
        if (to_perfect[c].empty()) {
            ans += beauty[c];
        }
        cout << ans << '\n';
    }
}