#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

struct point {
    ll x, y;
};

void dist(ll x1, ll x2, ll x3, ll y1, ll y2, ll y3) {
    ld a = sqrt((x3 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));
    ld b = sqrt((x3 - x1) * (x3 - x1) + (y3 - y1) * (y3 - y1));
    ld c = sqrt((x3 - x2) * (x3 - x2) + (y3 - y2) * (y3 - y2));
    ld h1 = b * b - (b * b - a * a + c * c) / 2 * c;
    ld h2 = a * a - (a * a - c * c + b * b) / 2 * b;
    ld h3 = c * c - (b * b - c * c - a * a) / 2 * a;
    if (h1 >= h2 && h1 >= h3) {
        cout << x2 << " " << y2 << " " << x3 << " " << y3 << "\n";
    } else if (h2 >= h1 && h2 >= h3) {
        cout << x1 << " " << y1 << " " << x3 << " " << y3 << "\n";
    } else if (h3 >= h1 && h3 >= h2) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2 << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    dist(x1, x2, x3, y1, y2, y3);
}
