#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <cmath>
#include <set>
using namespace std;
#define int long long
int mxd(int s, int n) {
    int res = -1;
    for (int d = 1; d * d <= n; d++) {
        if (s % d != 0)
            continue;
        if (d <= n)
            res = max(res, d);
        if (s / d <= n)
            res = max(res, s / d);
    }
    return res;
}

signed main() {
    int n, m;
    cin >> n >> m;
    if (n > m)
        swap(n, m);
    int s;
    cin >> s;
    if (n * m == s) {
        cout << "0\n";
        return 0;
    }
    if (s % n == 0 || s % m == 0) {
        cout << "1\n";
        return 0;
    }
    int mx = mxd(s, n);
    if (mx != -1 && s / mx <= m) {
        cout << "2\n";
        return 0;
    }
    int rs = mxd(n * m - s, n);
    if (rs != -1 && (n * m - s) / rs <= m) {
        cout << "2\n";
        return 0;
    }
    for (int k = 1; k < n; k++) {
        if (2 * k == n)
            continue;
        if (abs(s + k * m - n * m) % abs(2 * k - n) == 0) {
            cout << "2\n";
            return 0;
        }
    }
    if (n / 2 * m == s) {
        cout << "2\n";
        return 0;
    }
    cout << "3\n";
    return 0;
}