#include <iostream>
#include <cmath>
#include <map>
#include <vector>

using namespace std;

typedef long long INT;

int main()
{
	INT n, q;

	cin >> n >> q;
	// each element in graph stores color and number of colors refered to it
	vector<map<int, INT>> graph{(const unsigned int)(n)};

	struct color
	{
		INT NumInGraph;
		INT NumOfBigs; 
	};
	vector<color> cs{(const unsigned int)1e6};

	INT sum = 0;

	while (q-- > 0)
	{
		char sign;
		cin >> sign;
		INT u, v, c;
		cin >> u >> v >> c;

		u--, v--, c--;

		if (sign == '+')
		{
			INT& uc = graph[u][c];
			INT& vc = graph[v][c];
			uc++;
			vc++;

			if (cs[c].NumOfBigs == 0)
				sum -= cs[c].NumInGraph;
			cs[c].NumInGraph++;
			if (uc == 2)
				cs[c].NumOfBigs++;
			if (vc == 2)
				cs[c].NumOfBigs++;
			if (cs[c].NumOfBigs == 0)
				sum += cs[c].NumInGraph;
		}
		else if (sign == '-')
		{
			INT& uc = graph[u][c];
			INT& vc = graph[v][c];
			uc--; vc--;

			if (cs[c].NumOfBigs == 0)
				sum -= cs[c].NumInGraph;
			cs[c].NumInGraph--;
			if (uc == 1)
				cs[c].NumOfBigs--;
			if (vc == 1)
				cs[c].NumOfBigs--;

			if (cs[c].NumOfBigs == 0)
				sum += cs[c].NumInGraph;
		}

		cout << sum << endl;
	}

	return 0;
}