#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;


int main()
{
	ll n, m, s;
	cin >> n >> m >> s;

	if (n * m == s)
	{
		cout << 0;
		return 0;
	}

	for (ll i = 1; i * i <= s; i++)
		if (!(s % i))
			if ((i <= n && s / i <= m) || (i <= m && s / i <= n))
			{
				cout << 1;
				return 0;
			}

	if (s < max(n, m))
	{
		cout << 2;
		return 0;
	}

	for (ll i = 1; i * i <= n; i++)
		for (ll j = 1; j <= (m + 1) / 2; j++)
			if (i * j == s || i * j + (n - i) * (m - j) == s || n * m - i * j == s || n * m - (i * j + (n - i) * (m - j)) == s || (n - i) * (m - j) == s || n * m - (n - i) * (m - j) == s)
			{
				cout << 2;
				return 0;
			}
	cout << 3;

	return 0;
}