#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>

using namespace std;

typedef long long ll;


int main()
{
	ll n;
	cin >> n;

	vector<ll> a(n), b(n);
	for (ll& i : a)
		cin >> i;
	for (ll& i : b)
		cin >> i;

	vector<pair<ll, ll>> zov(n);
	for (ll i = 0; i < n; i++)
		zov[i] = { min(a[i], b[i]), max(a[i], b[i]) };
	sort(zov.begin(), zov.end());

	for (ll i = 1; i < n; i++)
		if (zov[i].second < zov[i - 1].second)
		{
			cout << -1;
			return 0;
		}
	
	for (ll i = 0; i < n; i++)
		cout << zov[i].first << ' ';
	cout << '\n';

	for (ll i = 0; i < n; i++)
		cout << zov[i].second << ' ';

	return 0;
}