#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;

void solve() {
    ll a, b;
    cin >> a >> b;
    ll x = 1;
    for (int i = 0; i < a; i++) {
        x *= 10;
    }
    ll t = gcd(x, b);
    x /= t;
    b /= t;
    if (x < 1e6 && b < 1e6) {
        cout << "YES\n" << b << " " << x;
    } else cout << -1;
}

void solve2() {
    int n, q;
    cin >> n >> q;
    map<int, int> am;
    map<int, set<int>> good;
    vector<map<int, int>> amounts(n + 1);

    for (int i = 1; i <= 1e5; ++i) {
        am[i] = 0;
        good[i] = {};
    }

    int ans = 0;
    for (int i = 0; i < q; ++i) {
        char x;
        cin >> x;
        int v, u, c;
        cin >> v >> u >> c;
        if (x == '+') {
            if (amounts[v][c] == 0 && amounts[u][c] == 0) {
                amounts[v][c]++;
                amounts[u][c]++;
                am[c]++;
                if (good[c].empty())
                    ++ans;
            } else {
                amounts[v][c]++;
                amounts[u][c]++;
                if (good[c].empty())
                    ans -= am[c];

                if(amounts[v][c] >= 2)
                    good[c].insert(v);
                if(amounts[u][c] >= 2)
                    good[c].insert(u);

                am[c]++;
            }
        } else {
            amounts[v][c]--;
            amounts[u][c]--;
            am[c]--;
            if (good[c].empty())
                ans -= 1;
            else {
                if(amounts[v][c] < 2)
                    good[c].erase(v);
                if(amounts[u][c] < 2)
                    good[c].erase(u);

                if (good[c].empty())
                    ans += am[c];
            }
        }
        cout << ans << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve2();
    return 0;
}
