#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long long ull;
typedef long double ldl;

ldl x1, y11, x2, y2, x3, y3, a1, b1, c1;
ldl def_val = 1e9, fi = 2 / (sqrt(5) + 1), eps = 1e-6;

ldl f(ldl a, ldl b, ldl c){
    ldl d1 = abs(a * x1 + b * y11 + c) / sqrt(a * a + b * b);
    ldl d2 = abs(a * x2 + b * y2 + c) / sqrt(a * a + b * b);
    ldl d3 = abs(a * x1 + b * y3 + c) / sqrt(a * a + b * b);
    return d1 + d2 + d3;
}

ldl g(ldl a, ldl b){
    ldl l = -def_val, r = def_val, m1, m2;

    while (r - l > eps){
        m1 = r - (r - l) * fi;
        m2 = l + (r - l) * fi;

        if (f(a, b, m1) > f(a, b, m2)) l = m1;
        else r = m2;
    }

    c1 = (l + r) / 2;
    return f(a, b, c1);
}

ldl h(ldl a){
    ldl l = -def_val, r = def_val, m1, m2;

    while (r - l > eps){
        m1 = r - (r - l) * fi;
        m2 = l + (r - l) * fi;

        if (g(a, m1) > g(a, m2)) l = m1;
        else r = m2;
    }

    b1 = (l + r) / 2;
    return g(a, b1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cout << setprecision(20);

    cin >> x1 >> y11 >> x2 >> y2 >> x3 >> y3;

    ldl l = -1e11, r = 1e11, m1, m2;
    while (r - l > eps){
        m1 = r - (r - l) * fi;
        m2 = l + (r - l) * fi;

        if (h(m1) > h(m2)) l = m1;
        else r = m2;
    }

    a1 = (l + r) / 2;

    if (b1 == 0){
        ldl x_ans = -c1 / a1;
        cout << round(x_ans) << ' ' << 0 << ' ' << round(x_ans) << ' ' << 1;
    } else {
        ldl y_ans = (-c1 - a1) / b1;
        cout << 1 << ' ' << round(y_ans) << ' ';
        ldl y_ans1 = (-c1 + a1) / b1;
        cout << -1 << ' ' << round(y_ans1);
    }

//    cout << '\n' << a1 << ' ' << b1 << ' ' << c1;

    return 0;
}
