#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;
template<typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct line {
    ll k, b;
    line() : k(0), b(0) {}
    line(ll _k, ll _b) : k(_k), b(_b) {}

    ll solve(ll need) {
        need -= b;
        if (need == 0) {
            if (k == 0) {
                return 1;
            } else {
                return 0;
            }
        }
        if (k == 0) return 0;

        if (need % k != 0) return 0;
        return need / k;
    }
};

int _solve(ll n, ll m, ll s) {
    if (s == n * m) return 0;
    if (s % n == 0 || s % m == 0) return 1;

    for (ll x = 1; x < m; x++) {
        for (int mask = 1; mask < (1 << 4); mask++) {
            ll k = 0, b = 0;
            if ((mask >> 0) & 1) k += x, b += 0;
            if ((mask >> 1) & 1) k += m - x, b += 0;
            if ((mask >> 2) & 1) k -= x, b += n * x;
            if ((mask >> 3) & 1) k -= m - x, b += (m - x) * n;

            line res = {k, b};
            ll y = res.solve(s);

//            cout << mask << ' ' << x << ' ' << m - x << ' ' << k << ' ' << res.k << ' ' << res.b << ' ' << y << endl;
            if (0 < y && y < n) return 2;
        }
    }

    return 3;
}

void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    cout << min(_solve(n, m, s), _solve(m, n, s)) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}