#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;
template<typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

array<ll, 3> line(ll x1, ll y1, ll x2, ll y2) {
    ll A = (y1 - y2);
    ll B = (x2 - x1);
    ll C = -x1 * A - y1 * B;
    return {A, B, C};
}

ld dist(array<ll, 3> l, ll x, ll y) {
    return abs(l[0] * x + l[1] * y + l[2]) / sqrtl(l[0] * l[0] + l[1] * l[1]);
}

void solve() {
    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    ld d1 = dist(line(x2, y2, x3, y3), x1, y1);
    ld d2 = dist(line(x1, y1, x3, y3), x2, y2);
    ld d3 = dist(line(x1, y1, x2, y2), x3, y3);

    if (d1 <= d2 && d1 <= d3) {
        cout << x2 << ' ' << y2 << ' ' << x3 << ' ' << y3 << '\n';
    } else if (d2 <= d1 && d2 <= d3) {
        cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3 << '\n';
    } else {
        cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}