#include <iostream>
#include <cmath>
#include <vector>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

bool can(ll t, ll n, ll m) {
    for (ll i = 1; i < n; i++) {
        if (t % i == 0 && t < m * i) return true;
    }
    return false;
}

int main() {
    ll n, m, s;
    cin >> n >> m >> s;
    ll res = 3;
    if (n * m == s) {
        res = 0;
    }
    if (s % n == 0 || s % m == 0) {
        res = min(res, 1LL);
    }
    ll add = n * m - s;
    if (can(add, n, m) || can(s, n, m)) {
        res = min(res, 2LL);
    }
    for (ll x = 1; 2 * x < n; x++) {
        ll l = 0, r = m;
        while (r - l > 1) {
            ll mm = (r + l) / 2;
            if (mm * x + (n - x) * (m - mm) <= s) {
                l = mm;
            } else {
                r = mm;
            }
        }
        if (l * x + (n - x) * (m - l) == s) res = min(res, 2LL);
    }
    cout << res;
    return 0;
}
