#include <iostream>
#include <cmath>
#include <vector>
#include <map>

#include <algorithm>
using namespace std;

using ll = long long;
using ld = long double;

void path(int side, int add, bool start) {
    if (side == 3) {
        if (start) {
            cout << 2 + add << " " << 0 + add << '\n';
        }
        cout << 0 + add << " " << 2 + add << '\n';
        cout << 3 + add << " " << 2 + add << '\n';
        cout << 0 + add << " " << -1 + add << '\n';
        cout << 0 + add << " " << 1 + add << '\n';
        return;
    }
    if (side == 4) {
        if (start) cout << 0 + add << " " << 3 + add << '\n';
        cout << 3 + add << " " << 3 + add << '\n';
        cout << 3 + add << " " << -1 + add << '\n';
        path(3, add, false);
        return;
    }
    if (side & 1) {
        if (start) cout << side - 1 + add << " " << 0 + add << '\n';
        cout << add << " " << add << '\n';
        cout << add << " " << side - 1 + add << '\n';
        path(side - 1, add + 1, false);
    } else {
        if (start) cout << 0 + add << " " << side - 1 + add << '\n';
        cout << side - 1 + add << " " << side - 1 + add << '\n';
        cout << side - 1 + add << " " << add << '\n';
        path(side - 1, add, false);
    }
}

int main() {
    int n;
    cin >> n;
    path(n, 0, true);
    return 0;
}
