#pragma GCC optimize("Ofast")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;
#define int long long
typedef long long ll;
typedef long double ld;

struct line {
    ld m, s;
    line(ld m, ld s): m(m), s(s) {}

    ld eval(ld x){
        return m * x + s;
    }
};

vector<line> cht;

ld xintersect(line a, line b){
    return ((ld)(b.s - a.s) / (a.m - b.m));
}

void addcht(line l){
    while (cht.size() >= 2 && (xintersect(l, cht[cht.size() - 2]) >= xintersect(l, cht[cht.size() - 1]))){
        cht.pop_back();
    }
    cht.push_back(l);
}

ld get_cht(ld x){
    ld res = min(cht[0].eval(x), cht.back().eval(x));
    int l = 1, r = cht.size() - 1;
    while (r - l > 1){
        int m = (r + l) / 2;
        if (cht[m - 1].eval(x) <= cht[m].eval(x)){
            r = m;
        } else {
            l = m;
        }
    }
    if (l < cht.size()){
        res = min(res, cht[l].eval(x));
    }
    return res;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(15);

    int n, m, c;
    cin >> n >> m >> c;
    vector<ld> x(n + 2), t(n + 2);
    for (int i = 1; i <= n; ++i){
        cin >> x[i] >> t[i];
    }
    x[0] = t[0] = 0;
    x[n + 1] = m;
    t[n + 1] = 0;

    n += 2;

    vector<ld> dp(n);
    dp[0] = 0;
    addcht(line(0, 0));
    for (int i = 1; i < n; ++i){
        dp[i] = get_cht(x[i]) + (ld) x[i] * x[i] / c;
        //cout << dp[i] << " ";
        addcht(line(((ld) -2 * x[i]) / c, (ld) x[i] * x[i] / c + dp[i] + t[i]));
    }
    cout << dp.back();


    return 0;
}

/*

4 100 25
10 50
15 30
50 100
80 60

*/
