#include <bits/stdc++.h>

using namespace std;

#define ld long long
#define int long long

const ld eps = 1e-9;

struct vec {
    ld x, y;
    vec() : x(0), y(0){}
    vec(ld x1, ld y1): x(x1), y(y1) {}
    vec(vec a1, vec a2): x(a2.x - a1.x), y(a2.y - a1.y) {}
};

ld lenlen(vec a) {
    return (a.x * a.x + a.y * a.y);
}

vec operator+ (vec a, vec b) {
    return vec(a.x + b.x, a.y + b.y);
}

vec operator- (vec a, vec b) {
    return vec(a.x - b.x, a.y - b.y);
}

ld operator% (vec a, vec b) {
    return a.x * b.y - a.y * b.x;
}

istream& operator >>(istream& in, vec& a) {
    in >> a.x >> a.y;
    return in;
}

ostream& operator <<(ostream& out, const vec & a) {
    return out << a.x << " " << a.y << "\n";
}

vec vys(vec a, vec b, vec p) {
    return vec(p.x + b.y - a.y, p.y + a.x - b.x);
}

void solve()
{
    vec a, b, c;
    cin >> a >> b >> c;
    ld s = (c - a) % (b - a);
    if (s == 0) {
        cout << a << b;
        return;
    }
    int mxa = lenlen(c - b);
    int mxb = lenlen(a - c);
    int mxc = lenlen(a - b);
    if (mxa >= mxb && mxa >= mxc) {
        cout << a << vys(b, c, a);
    }
    if (mxb >= mxa && mxb >= mxc) {
        cout << b << vys(a, c, b);
    }
    if (mxc >= mxb && mxc >= mxa) {
        cout << c << vys(a, b, c);
    }
}

signed main()
{
#ifdef Lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
#endif

    int _ = 1;
    //cin >> _;
    while (_--)
    {
        solve();
    }
}
