x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
a = list(map(int, input().split()))

s = (x0, y0)
t = (x1, y1)

def mul_k_p(k, p):
    return (p[0] * k, p[1] * k)

def add_p_p(p1, p2):
    return (p1[0] + p2[0], p1[1] + p2[1])

def sub_p_p(p1, p2):
    return add_p_p(p1, mul_k_p(-1, p2))

def get_dist(p1, p2):
    return ((p2[0] - p1[0]) ** 2 + (p2[1] - p1[1]) ** 2) ** 0.5

def get_norm_v(p1, p2):
    if p1 == p2:
        return (1, 0)
    v = sub_p_p(p2, p1)
    d = get_dist(p2, p1)
    return mul_k_p(1 / d, v)

def get_third_point(p1, p2, r1, r2, d):
    a = (r1 ** 2 - r2 ** 2 + d ** 2) / 2 / d
    h = (r1 ** 2 - a ** 2) ** 0.5
    p3 = add_p_p(p1, mul_k_p(a / d,  sub_p_p(p2, p1)))
    x4 = p3[0] + h * (p2[1] - p1[1]) / d
    y4 = p3[1] - h * (p2[0] - p1[0]) / d
    return (x4, y4)



dist = get_dist(s, t)

if 2 * max(a) - sum(a) > dist or dist > sum(a):
    print('Impossible')
    exit()

print('Possible')
if n == 1:
    print(x1, y1)
    exit()

a.append(dist)
sm = dist
mx = dist, n

for i in range(n):
    sm += a[i]
    if mx[0] < a[i]:
        mx = a[i], i

sm -= mx[0]
k = -1
pref = 0
suf = sm

while pref + mx[0] < suf:
    k += 1
    if k != mx[1]:
        pref += a[k]
        suf -= a[k]
ans = [(-1, -1)] * n

# dist = max
p = get_third_point(s, t, pref, suf, mx[0])
v1 = get_norm_v(s, p)
v2 = get_norm_v(p, t)
cur = s
for i in range(k + 1):
    cur = add_p_p(cur, mul_k_p(a[i], v1))
    ans[i] = cur
for i in range(k + 1, n):
    cur = add_p_p(cur, mul_k_p(a[i], v2))
    ans[i] = cur

for i in range(n):
    print('{:.8f} {:.8f}'.format(ans[i][0], ans[i][1]))