#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solveTest() {
  int n, m, k; cin >> n >> m >> k;
  vector<int> p(n);
  for (int& x : p) {
    cin >> x;
    --x;
  }
  vector<int> a(m);
  for (int& x : a) {
    cin >> x;
    --x;
  }
  vector<pair<int, int>> segments(k);
  for (auto& [l, r] : segments) {
    cin >> l >> r;
    --l;
  }
  vector<int> ans;
  vector<int> cur;
  vector<bool> used(k);
  auto rec = [&](auto self, int cnt) -> void {
    if (!ans.empty() && cur.size() + 1 >= ans.size()) {
      return;
    }
    for (int i = 0; i < k; ++i) {
      if (!used[i]) {
        int newCnt = cnt;
        used[i] = true;
        cur.push_back(i);

        auto[l, r] = segments[i];
        for (int pos = l; pos < r; ++pos) {
          int x = a[pos];
          if (x != p[newCnt]) {
            newCnt = 0;
          }
          if (x == p[newCnt]) {
            newCnt++;
          } else {
            newCnt = 0;
          }
          if (newCnt == n) {
            ans = cur;
            cur.pop_back();
            used[i] = false;
            return;
          }
        }

        self(self, newCnt);

        cur.pop_back();
        used[i] = false;
      }
    }
  };
  rec(rec, 0);
  if (ans.empty()) {
    cout << -1 << "\n";
  } else {
    cout << ans.size() << "\n";
    for (int x : ans) {
      cout << x + 1 << " ";
    }
    cout << "\n";
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int t; cin >> t;
  while (t--) solveTest();

  
  return 0;
}
