#include <bits/stdc++.h>
 
using namespace std;
 
long long distance(long long x1, long long y1, long long x2, long long y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

const int MAX_COORD = 1e9;
 
int main() {
    long long x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    long long d12 = distance(x1, y1, x2, y2);
    long long d13 = distance(x1, y1, x3, y3);
    long long d23 = distance(x2, y2, x3, y3);
    long long maxDist = max({d12, d13, d23});
    long long ansx1 = 0, ansy1 = 0, ansx2 = 0, ansy2 = 0;
    if (maxDist == d12) {
        ansx1 = x1;
        ansy1 = y1;
        ansx2 = x2;
        ansy2 = y2;
    } else if (maxDist == d13) {
        ansx1 = x1;
        ansy1 = y1;
        ansx2 = x3;
        ansy2 = y3;
    } else {
        ansx1 = x2;
        ansy1 = y2;
        ansx2 = x3;
        ansy2 = y3;
    }
    long long g = gcd(ansx1 - ansx2, ansy1 - ansy2);
    long long dx = (ansx2 - ansx1) / g;
    long long dy = (ansy2 - ansy1) / g;
    long long mn_coef = min((ansx1 - MAX_COORD) / dx, (ansy1 - MAX_COORD) / dy) + 1;
    long long mx_coef = min((MAX_COORD - ansx1) / dx, (MAX_COORD - ansy1) / dy) - 1;
    cout << ansx1 + mn_coef * dx << " " << ansy1 + mn_coef * dy << " ";
    cout << ansx1 + mx_coef * dx << " " << ansy1 + mx_coef * dy << endl;
    return 0;
}
