#include <algorithm>
#include <cmath>
#include <iostream>
#include <cstdlib>
#include <string>
#include <vector>

using namespace std;
typedef long long ll;
typedef long double ld;

void solved()
{
  ll n, m, s, S;
  cin >> n >> m >> s;
  S = n * m;
  if (s == S)
  {
    cout << 0;
    return;
  }
  if (s % n == 0 || s % m == 0)
  {
    cout << 1;
    return;
  }
  // if (n > m)
  //   swap(n, m);
  for (ll i = 1; i < n; i++)
    for (ll j = 1; j < m; j++)
    {
      ll
        s1 = i * j,
        s2 = (n - i) * j,
        s3 = (m - j) * i,
        s4 = (m - j) * (n - i);
      if (s1 == s || s2 == s || s3 == s || s4 == s ||
        s1 + s4 == s || s2 + s3 == s || s == S - s1 ||
        s == S - s2 || s == S - s3 || s == S - s4)
      {
        cout << 2;
        return;
      }
    }
  // ll x1 = s % n, x2 = s % m, k1 = s / n, k2 = s / m;
  // if (x1 == m - k1 || x2 == n - k2 || m - k1 == 1 || n - k2 == 1)
  // {
  //   cout << 2;
  //   return;
  // }

  cout << 3;
}

ld dist( ld x0, ld y0, ld x1, ld y1 )
{
  ld x = x1 - x0;
  ld y = y1 - y0;
  return sqrt(x * x + y * y);
}

void solvee()
{
  ld x0, y0, x1, y1;
  cin >> x0 >> y0 >> x1 >> y1;
  int n;
  cin >> n;
  vector<ld> a(n);
  ld l = 0;
  for (int i = 0; i < n; i++)
  {
    cin >> a[i];
    l += a[i];
  }

  if (dist(x0, y0, x1, y1) > l)
  {
    cout << "Impossible";
    return;
  }

  cout << "Possible\n";
  ld cx = x0, cy = y0, pd = dist(x0, y0, x1, y1), cd = 0;
  for (int i = 0; i < n - 1; i++)
  {
    ld x = a[i];
    cout << cx << ' ' << cy << '\n';
    ld nx = cx + x, ny = cy;
    l -= x;
    cd = dist(nx, cy, x1, y1);
    if (cd >= l)
    {
      ld b = acos((pd * pd + x * x - l * l) / (2 * x * pd));
      ld g = acos((pd * pd + x * x - cd * cd) / (2 * pd * x));
      ld al = g - b;
      nx = x * cos(al) + cx;
      ny = cy + sin(al) * x;
      ld dx = x1 - nx, dy = y1 - ny;
      cout << nx << ' ' << ny;
      for (int j = i + 1; j < n - 1; j++)
      {
        cx = nx;
        nx = cx + a[j] * dx;
        cy = ny;
        ny = cy + a[j] * dy;
        cout << nx << ' ' << ny << '\n';
      }
      cout << x1 << ' ' << y1;
      return;
    }
    pd = cd;
    cx = nx;
  }
}

void solveh()
{
  ll n, q;
  cin >> n >> q;
  
  // vector<
  // for (int i = 0; i < q; i++)
  // {
  //   char s;
  //   int v, u, c;
  //   cin >> s >> v >> u >> c;
  //   if (s == '+')
  //   {
  //   }
  //   else if (s == '-')
  //   {
  //   }
  // }
}

void solvei()
{
  ll n;
  cin >> n;
  vector<pair<ll, ll>> a(n);
  for (int i = 0; i < n; i++)
    cin >> a[i].first;
  for (int i = 0; i < n; i++)
    cin >> a[i].second;
  for (int i = 0; i < n; i++)
    if (a[i].first > a[i].second)
      swap(a[i].first, a[i].second);
  sort(a.begin(), a.end(), [](pair<ll, ll> f, pair<ll, ll> s) { return f.first < s.first; });
  for (int i = 0; i < n - 1; i++)
    if (a[i].second > a[i + 1].second)
    {
      cout << "-1";
      return;
    }
  for (int i = 0; i < n; i++)
    cout << a[i].first << ' ';
  cout << '\n';
  for (int i = 0; i < n; i++)
    cout << a[i].second << ' ';
}

void solvej()
{
  int t = 7, r = 7, b = 0, l = 0;

  int xm = 4, ym = 4;

  cout << '?' << xm << ym << endl;
  char s;
  cin >> s;
  
  do
  {

  } while (l != r && b != t);
}

void solvem()
{
  ll x1, y1, x2, y2, x3, y3;
  cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
  
  ld dist = 1e10;
  ll rx1, ry1, rx2, ry2;
  {
    ll a = y2 - y1;
    ll b = x1 - x2;
    ll c = -b * y1 - a * x1;

    ld h = abs(a * x3 + b * y3 + c) * 1.0 / sqrt(a * a + b * b);
    if (h < dist)
    {
      rx1 = x1, rx2 = x2, ry1 = y1, ry2 = y2;
      dist = h;
    }
  }
  {
    ll a = y3 - y1;
    ll b = x1 - x3;
    ll c = -b * y1 - a * x1;

    ld h = abs(a * x2 + b * y2 + c) * 1.0 / sqrt(a * a + b * b);
    if (h < dist)
    {
      rx1 = x1, rx2 = x3, ry1 = y1, ry2 = y3;
      dist = h;
    }
  }
  {
    ll a = y2 - y3;
    ll b = x3 - x2;
    ll c = -b * y3 - a * x3;

    ld h = abs(a * x1 + b * y1 + c) * 1.0 / sqrt(a * a + b * b);
    if (h < dist)
    {
      rx1 = x2, rx2 = x3, ry1 = y2, ry2 = y3;
      dist = h;
    }
  }
  cout << rx1 << ' ' << ry1 << ' ' << rx2 << ' ' << ry2;
}

int main()
{
  solvei();
}
