#include <iostream>
#include <cmath>
using namespace std;

using UINT64 = unsigned long long;
using INT64 = long long;

unsigned long long Power( UINT64 A, UINT64 Power )
{
	UINT64 res = 1;

	for (UINT64 i = 0; i < Power; i++)
		res *= A;

	return res;
}

int main(void)
{
	int n, x;
	UINT64 p;

	std::cin >> n >> x;

	p = Power(10, n);

	if (x > p || p >= 1000000)
	{
		cout << "NO";
		return 0;
	}

	cout << "YES" << endl;
	cout << x << ' ' << p;

	return 0;
}