#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;


int main()
{
	ll n, m, s;
	cin >> n >> m >> s;

	if (n * m == s)
	{
		cout << 0;
		return 0;
	}

	for (ll i = 1; i * i <= s; i++)
		if (!(s % i))
			if ((i <= n && s / i <= m) || (i <= m && s / i <= n))
			{
				cout << 1;
				return 0;
			}
	
	for (ll i = 1; i <= n; i++)
	{
		ll l = 0, r = m + 1;
		while (l + 1 < r)
		{
			ll mid = (l + r) / 2;

			if (i * mid > s)
				r = mid;
			else if (i * mid + (n - i) * (m - i) == s)
			{
				cout << 2;
				return 0;
			}
			else
				l = mid;
		}
	}
	cout << 3;

	return 0;
}