#include <iostream>
#include <string>
#include <map>
#include <cmath>
using namespace std;

long long gcd(long long a, long long b) {
	while (a > 0) {
		b %= a;
		swap(a, b);
	}
	return b;
}

int main() {
	long long n, otv, a, b;
	cin >> n >> otv;
	a = otv;
	b = pow(10, n);
	if (a < b) {
		long long g = gcd(a, b);
		while (g != 1) {
			a /= g;
			b /= g;
			g = gcd(a, b);
		}
		if (b >= 1000000)
			cout << "NO";
		else
			cout << "YES" << '\n' << a << " " << b;
	}
	else {
		cout << "NO";
	}
}