#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;
template<typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) cin >> v[i].first;
    for (int i = 0; i < n; i++) cin >> v[i].second;
    sort(v.begin(), v.end(), [&](pair<int, int> a, pair<int, int> b) {
        return a.first + a.second < b.first + b.second;
    });

    for (int i = 1; i < n; i++) {
        if (!(v[i - 1].first <= v[i].first && v[i - 1].second <= v[i].second)) swap(v[i].first, v[i].second);
        if (!(v[i - 1].first <= v[i].first && v[i - 1].second <= v[i].second)) {
            cout << "-1";
            return;
        }
    }

    for (int i = 0; i < n; i++) cout << v[i].first << " ";
    cout << "\n";
    for (int i = 0; i < n; i++) cout << v[i].second << " ";
    cout << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}