import math

x1, y1, x2, y2, x3, y3 = [int(i) for i in input().split()]

def build(x1, y1, x2, y2):
    if x1 == x2:
        return 1, 0, -x1
    k = (y1 - y2) / (x1 - x2)
    b = y1 - k * x1
    
    return k, -1, b

pts = [
    (x1, y1),
    (x2, y2),
    (x3, y3)
]

mind, minpts = -1, None

for i in range(0, 3):
    p1 = pts[i]
    p2, p3 = pts[:i] + pts[i + 1:]
    
    a, b, c = build(*p2, *p3)
    
    d = abs(a * p1[0] + b * p1[1] + c) / math.sqrt(a *a + b * b)
    
    if mind < 0 or d < mind:
        mind, minpts = d, (p2, p3)
        
print(*minpts[0], *minpts[1])