#include <iostream>
#include <cmath>
#include <vector>
using namespace std;

using ld = long double;
using ll = long long;

struct vec {
	ll x;
	ll y;
	vec(ll x1, ll y1) {
		x = x1;
		y = y1;
	}
};

ll dist(vec a, vec b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}



int main() {
	ll x1, x2, x3, y1, y2, y3;
	cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
	vec A(x1, y1);
	vec B(x2, y2);
	vec C(x3, y3);
	ll da = dist(B, C);
	ld db = dist(A, C);
	ld dc = dist(B, A);
	if (da >= db && da >= dc) {
		cout << B.x << ' ' << B.y << ' ' << C.x << ' ' << C.y;
	}
	else if (db >= da && db >= dc) {
		cout << A.x << ' ' << A.y << ' ' << C.x << ' ' << C.y;
	}
	else if (dc >= db && dc >= da) {
		cout << A.x << ' ' << A.y << ' ' << B.x << ' ' << B.y;
	}
}