#include <bits/stdc++.h>

using namespace std;
#define int long long
typedef long long ll;
typedef long double ld;

bool ask(int x, int y) {
    if (x == 0 || y == 0) {
        return true;
    }
    if (abs(x) >= 8 || abs(y) >= 8) {
        return false;
    }
    cout << "? " << x << " " << y << endl;
    char c;
    cin >> c;
    return (c == '+');
}

int bin1() {
    int dist = 0;
    int l = 0, r = 8;
    while (r - l > 1) {
        int m = (r + l + 1) / 2;
        int x = m - dist;
        if (ask(-x, -x)) {
            dist = m;
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

int bin2(int add) {
    int dist = -add;
    int l = 0, r = 8;
    while (r - l > 1) {
        int m = (r + l + 1) / 2;
        int x = m - dist;
        if (ask(x, x)) {
            dist = m;
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

void solve() {
    int a = bin1();
    int b = bin2(a);
    bool flag = ask(1, -1);
    for (int i = 1; i <= 8; ++i) {
        for (int j = 1; j <= 8; ++j) {
            int c = min(i, j) - 1;

            int d = min(9 - i, 9 - j) - 1;

            if (a == c && b == d) {
                if ((flag && i > j) || (!flag && i <= j)) {
                    cout << "! " << char('a' + j - 1) << i << endl;
                    return;
                }
            }
        }
    }
}


struct point {
    ld x, y;

    point(ld x1, ld x2) {
        x = x1;
        y = x1;
    }

    point() {
        x = 0;
        y = 0;
    }

};

struct line {
    ld a, b, c;

    line(point q, point w) {
        a = w.y - q.y;
        b = q.x - w.x;
        c = a * q.x + b * q.y;
        c *= -1;
    }

    line() {
        a = 0;
        b = 0;
        c = 0;
    }
};

ld distpl(point a, line b) {
    return abs((a.x * b.a + a.y * b.b + b.c) / sqrtl(b.a * b.a + b.b * b.b));
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n; cin >> n;
    if (n == 3) {
        cout << 0 << " " << 0 << "\n";
        cout << 0 << " " << 3 << "\n";
        cout << 3 << " " << 0 << "\n";
        cout << 0 << " " << 0 << "\n";
        cout << 2 << " " << 2 << "\n";
        return 0;
    }
    cout << 0 << " " << 0 << "\n";
    cout << n - 1 << " " << 0 << "\n";
    int x = n - 1, y = 0;
    bool d = true;

    int k = n - 1;

    for (int i = 0; i < n - 3; i++) {
        if (d) {
            y += k;
            cout << x << " " << y << "\n";
            if (i == n - 4)
                break;
            x -= k;
            cout << x << " " << y << "\n";
        } else {
            y -= k;
            cout << x << " " << y << "\n";
            if (i == n - 4)
                break;
            x += k;
            cout << x << " " << y << "\n";
        }
        d ^= 1;
        k--;
    }

    if (n == 3) {
        cout << 0 << " " << 3 << "\n";
        cout << 3 << " " << 0 << "\n";
        cout << 0 << " " << 0 << "\n";
        cout << 2 << " " << 2 << "\n";
    } else {
        if (!d) {
            cout << x + 4 << " " << y << "\n";
            cout << x + 1 << " " << y + 3 << "\n";
            cout << x + 1 << " " << y << "\n";
            cout << x + 3 << " " << y + 2 << "\n";
        } else {
            cout << x - 4 << " " << y << "\n";
            cout << x - 1 << " " << y - 3 << "\n";
            cout << x - 1 << " " << y << "\n";
            cout << x - 3 << " " << y - 2 << "\n";
        }
    }
/*
    int n;
    cin >> n;
    vector<vector<int>> arr(n, vector<int>(n, 0));
    for (int i = 0; i < n; ++i) {
        arr[0][i] = 1;
    }
    for (int i = 1; i < n; ++i) {
        arr[i][0] = 2;
    }
    arr.back()[1] = 2;
    for (int i = 2; i < n; ++i) {
        arr.back()[i] = 3;
    }
    arr[n - 2][n - 1] = 3;
    arr[n - 3][n - 1] = 3;
    for (int i = 1; i < n - 3; ++i) {
        arr[i][n - 1] = 4;
    }
    arr[1][n - 2] = 4;
    arr[1][n - 3] = 4;
    arr[1][n - 4] = 4;
    arr[2][n - 4] = 4;
    for (int i = 1; i < n - 1; ++i) {
        arr[i][1] = 5;
    }
    arr[n - 2][2] = 5;
    arr[n - 3][2] = 5;
    for (int i = 2; i <= n - 5; ++i) {

    }*/
    return 0;
}

/*



*/
