#include <vector>
#include <iostream>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

long long gcd(long long a, long long b) {
	if (b > a) {
		int temp = b;
		b = a;
		a = temp;
	}
	while (a % b != 0) {
		a %= b;
		if (a < b) {
			ull temp = a;
			a = b;
			b = temp;
		}
	}
	return b;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ld c, h;
	cin >> c >> h;
	double diskr = c * c - 4 * h * h;
	if (diskr < 0) {
		cout << -1;
	}
	else {
		double y1 = (c - sqrt(c * c - 4 * h * h)) / (2);
		double y2 = (c + sqrt(c * c - 4 * h * h)) / (2);

		double x1 = c - y1;
		double x2 = c - y2;

		double a1 = sqrt(x1 * x1 + h * h);
		double a2 = sqrt(x2 * x2 + h * h);

		double b1 = sqrt(y1 * y1 + h * h);
		double b2 = sqrt(y2 * y2 + h * h);

		if (a1 + b1 > c && a2 + b2 > c && a1*a1 + b1*b1 == c*c && a2*a2 + b2*b2 == c*c) {
			cout << (c * h) / 2;
		}
		else {
			cout << -1;
		}
	}





}