#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pld = pair<ll, ll>;
using pii = pair<int, int>;
const ll mx = 1e6;
const ld inf = 1e18;
void solve() {
    int n, m;
    ld c;
    cin >> n >> m >> c;
    vector<ll> x(n + 2), t(n + 2);
    x[0] = t[0] = 0;
    for (int i = 1; i <= n; ++i) cin >> x[i] >> t[i];
    x[n + 1] = m, t[n + 1] = 0;
    vector<ld> dp(n + 2, inf);
    dp[0] = 0;
    int ml = 0;
    for (int i = 1; i <= n + 1; ++i) {
        for (int j = ml; j < i; ++j) {
            if (dp[j] + (x[i] - x[j]) * (x[i] - x[j]) < dp[i]) {
                dp[i] = dp[j] + (x[i] - x[j]) * (x[i] - x[j]) / c;
            } 
        }
        dp[i] += t[i];
    }
    cout << fixed << (dp[n + 1]) << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(16);
    int t;
    t = 1;

    while (t--) {
        solve();
    }
    return 0;
}