#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < n; ++i) if (a[i] > b[i]) swap(a[i], b[i]);
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int x, int y) {
        if (a[x] != a[y]) return a[x] < a[y];
        return b[x] < b[y];
    });
    vector<int> a1, a2;
    for (int i : ord) {
        if (a1.empty()) {
            a1.push_back(a[i]);
            a2.push_back(b[i]);
            continue;
        }
        if (a1.back() > a[i]) {
            cout << "-1\n";
            return;
        }
        a1.push_back(a[i]);
        if (a2.back() > b[i]) {
            cout << "-1\n";
            return;
        }
        a2.push_back(b[i]);
    }
    for (int i : a1) cout << i << ' ';
    cout << '\n';
    for (int i : a2) cout << i << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    t = 1;

    while (t--) {
        solve();
    }
    return 0;
}